// A Bison parser, made by GNU Bison 3.5.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2019 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// Undocumented macros, especially those whose name start with YY_,
// are private implementation details.  Do not rely on them.



// First part of user prologue.
#line 29 "src/parser.yy"

#include <iostream>

#include "driver.h"

void yyerror(bpftrace::Driver &driver, const char *s);

#line 48 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"


#include "parser.tab.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 4 "src/parser.yy"
namespace  bpftrace  {
#line 145 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"


  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
   Parser ::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
   Parser :: Parser  (bpftrace::Driver &driver_yyarg, void *yyscanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

   Parser ::~ Parser  ()
  {}

   Parser ::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | Symbol types.  |
  `---------------*/



  // by_state.
   Parser ::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

   Parser ::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
   Parser ::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
   Parser ::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

   Parser ::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

   Parser ::symbol_number_type
   Parser ::by_state::type_get () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

   Parser ::stack_symbol_type::stack_symbol_type ()
  {}

   Parser ::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.type_get ())
    {
      case 78: // attach_point
        value.YY_MOVE_OR_COPY< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case 77: // attach_points
        value.YY_MOVE_OR_COPY< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case 93: // call
        value.YY_MOVE_OR_COPY< ast::Call * > (YY_MOVE (that.value));
        break;

      case 90: // expr
      case 91: // pre_post_op
      case 96: // map_or_var
        value.YY_MOVE_OR_COPY< ast::Expression * > (YY_MOVE (that.value));
        break;

      case 97: // vargs
        value.YY_MOVE_OR_COPY< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case 89: // int
        value.YY_MOVE_OR_COPY< ast::Integer * > (YY_MOVE (that.value));
        break;

      case 94: // map
        value.YY_MOVE_OR_COPY< ast::Map * > (YY_MOVE (that.value));
        break;

      case 82: // param
        value.YY_MOVE_OR_COPY< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case 80: // pred
        value.YY_MOVE_OR_COPY< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case 76: // probe
        value.YY_MOVE_OR_COPY< ast::Probe * > (YY_MOVE (that.value));
        break;

      case 75: // probes
        value.YY_MOVE_OR_COPY< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case 84: // semicolon_ended_stmt
      case 86: // block_stmt
      case 87: // stmt
      case 88: // compound_assignment
        value.YY_MOVE_OR_COPY< ast::Statement * > (YY_MOVE (that.value));
        break;

      case 83: // block
      case 85: // stmts
        value.YY_MOVE_OR_COPY< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case 81: // ternary
        value.YY_MOVE_OR_COPY< ast::Ternary * > (YY_MOVE (that.value));
        break;

      case 95: // var
        value.YY_MOVE_OR_COPY< ast::Variable * > (YY_MOVE (that.value));
        break;

      case 67: // "integer"
      case 68: // "colon surrounded integer"
        value.YY_MOVE_OR_COPY< long > (YY_MOVE (that.value));
        break;

      case 55: // "builtin"
      case 56: // "call"
      case 57: // "call_builtin"
      case 58: // "identifier"
      case 59: // "path"
      case 60: // "preprocessor directive"
      case 61: // "struct definition"
      case 62: // "enum"
      case 63: // "string"
      case 64: // "map"
      case 65: // "variable"
      case 66: // "positional parameter"
      case 69: // "stack_mode"
      case 74: // c_definitions
      case 79: // wildcard
      case 92: // ident
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

   Parser ::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.type_get ())
    {
      case 78: // attach_point
        value.move< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case 77: // attach_points
        value.move< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case 93: // call
        value.move< ast::Call * > (YY_MOVE (that.value));
        break;

      case 90: // expr
      case 91: // pre_post_op
      case 96: // map_or_var
        value.move< ast::Expression * > (YY_MOVE (that.value));
        break;

      case 97: // vargs
        value.move< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case 89: // int
        value.move< ast::Integer * > (YY_MOVE (that.value));
        break;

      case 94: // map
        value.move< ast::Map * > (YY_MOVE (that.value));
        break;

      case 82: // param
        value.move< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case 80: // pred
        value.move< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case 76: // probe
        value.move< ast::Probe * > (YY_MOVE (that.value));
        break;

      case 75: // probes
        value.move< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case 84: // semicolon_ended_stmt
      case 86: // block_stmt
      case 87: // stmt
      case 88: // compound_assignment
        value.move< ast::Statement * > (YY_MOVE (that.value));
        break;

      case 83: // block
      case 85: // stmts
        value.move< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case 81: // ternary
        value.move< ast::Ternary * > (YY_MOVE (that.value));
        break;

      case 95: // var
        value.move< ast::Variable * > (YY_MOVE (that.value));
        break;

      case 67: // "integer"
      case 68: // "colon surrounded integer"
        value.move< long > (YY_MOVE (that.value));
        break;

      case 55: // "builtin"
      case 56: // "call"
      case 57: // "call_builtin"
      case 58: // "identifier"
      case 59: // "path"
      case 60: // "preprocessor directive"
      case 61: // "struct definition"
      case 62: // "enum"
      case 63: // "string"
      case 64: // "map"
      case 65: // "variable"
      case 66: // "positional parameter"
      case 69: // "stack_mode"
      case 74: // c_definitions
      case 79: // wildcard
      case 92: // ident
        value.move< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

#if YY_CPLUSPLUS < 201103L
   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.type_get ())
    {
      case 78: // attach_point
        value.copy< ast::AttachPoint * > (that.value);
        break;

      case 77: // attach_points
        value.copy< ast::AttachPointList * > (that.value);
        break;

      case 93: // call
        value.copy< ast::Call * > (that.value);
        break;

      case 90: // expr
      case 91: // pre_post_op
      case 96: // map_or_var
        value.copy< ast::Expression * > (that.value);
        break;

      case 97: // vargs
        value.copy< ast::ExpressionList * > (that.value);
        break;

      case 89: // int
        value.copy< ast::Integer * > (that.value);
        break;

      case 94: // map
        value.copy< ast::Map * > (that.value);
        break;

      case 82: // param
        value.copy< ast::PositionalParameter * > (that.value);
        break;

      case 80: // pred
        value.copy< ast::Predicate * > (that.value);
        break;

      case 76: // probe
        value.copy< ast::Probe * > (that.value);
        break;

      case 75: // probes
        value.copy< ast::ProbeList * > (that.value);
        break;

      case 84: // semicolon_ended_stmt
      case 86: // block_stmt
      case 87: // stmt
      case 88: // compound_assignment
        value.copy< ast::Statement * > (that.value);
        break;

      case 83: // block
      case 85: // stmts
        value.copy< ast::StatementList * > (that.value);
        break;

      case 81: // ternary
        value.copy< ast::Ternary * > (that.value);
        break;

      case 95: // var
        value.copy< ast::Variable * > (that.value);
        break;

      case 67: // "integer"
      case 68: // "colon surrounded integer"
        value.copy< long > (that.value);
        break;

      case 55: // "builtin"
      case 56: // "call"
      case 57: // "call_builtin"
      case 58: // "identifier"
      case 59: // "path"
      case 60: // "preprocessor directive"
      case 61: // "struct definition"
      case 62: // "enum"
      case 63: // "string"
      case 64: // "map"
      case 65: // "variable"
      case 66: // "positional parameter"
      case 69: // "stack_mode"
      case 74: // c_definitions
      case 79: // wildcard
      case 92: // ident
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.type_get ())
    {
      case 78: // attach_point
        value.move< ast::AttachPoint * > (that.value);
        break;

      case 77: // attach_points
        value.move< ast::AttachPointList * > (that.value);
        break;

      case 93: // call
        value.move< ast::Call * > (that.value);
        break;

      case 90: // expr
      case 91: // pre_post_op
      case 96: // map_or_var
        value.move< ast::Expression * > (that.value);
        break;

      case 97: // vargs
        value.move< ast::ExpressionList * > (that.value);
        break;

      case 89: // int
        value.move< ast::Integer * > (that.value);
        break;

      case 94: // map
        value.move< ast::Map * > (that.value);
        break;

      case 82: // param
        value.move< ast::PositionalParameter * > (that.value);
        break;

      case 80: // pred
        value.move< ast::Predicate * > (that.value);
        break;

      case 76: // probe
        value.move< ast::Probe * > (that.value);
        break;

      case 75: // probes
        value.move< ast::ProbeList * > (that.value);
        break;

      case 84: // semicolon_ended_stmt
      case 86: // block_stmt
      case 87: // stmt
      case 88: // compound_assignment
        value.move< ast::Statement * > (that.value);
        break;

      case 83: // block
      case 85: // stmts
        value.move< ast::StatementList * > (that.value);
        break;

      case 81: // ternary
        value.move< ast::Ternary * > (that.value);
        break;

      case 95: // var
        value.move< ast::Variable * > (that.value);
        break;

      case 67: // "integer"
      case 68: // "colon surrounded integer"
        value.move< long > (that.value);
        break;

      case 55: // "builtin"
      case 56: // "call"
      case 57: // "call_builtin"
      case 58: // "identifier"
      case 59: // "path"
      case 60: // "preprocessor directive"
      case 61: // "struct definition"
      case 62: // "enum"
      case 63: // "string"
      case 64: // "map"
      case 65: // "variable"
      case 66: // "positional parameter"
      case 69: // "stack_mode"
      case 74: // c_definitions
      case 79: // wildcard
      case 92: // ident
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
   Parser ::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
   Parser ::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
#if defined __GNUC__ && ! defined __clang__ && ! defined __ICC && __GNUC__ * 100 + __GNUC_MINOR__ <= 408
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
#endif
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  void
   Parser ::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
   Parser ::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
   Parser ::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
   Parser ::debug_stream () const
  {
    return *yycdebug_;
  }

  void
   Parser ::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


   Parser ::debug_level_type
   Parser ::debug_level () const
  {
    return yydebug_;
  }

  void
   Parser ::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

   Parser ::state_type
   Parser ::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  bool
   Parser ::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
   Parser ::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
   Parser ::operator() ()
  {
    return parse ();
  }

  int
   Parser ::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", static_cast<state_type> (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case 78: // attach_point
        yylhs.value.emplace< ast::AttachPoint * > ();
        break;

      case 77: // attach_points
        yylhs.value.emplace< ast::AttachPointList * > ();
        break;

      case 93: // call
        yylhs.value.emplace< ast::Call * > ();
        break;

      case 90: // expr
      case 91: // pre_post_op
      case 96: // map_or_var
        yylhs.value.emplace< ast::Expression * > ();
        break;

      case 97: // vargs
        yylhs.value.emplace< ast::ExpressionList * > ();
        break;

      case 89: // int
        yylhs.value.emplace< ast::Integer * > ();
        break;

      case 94: // map
        yylhs.value.emplace< ast::Map * > ();
        break;

      case 82: // param
        yylhs.value.emplace< ast::PositionalParameter * > ();
        break;

      case 80: // pred
        yylhs.value.emplace< ast::Predicate * > ();
        break;

      case 76: // probe
        yylhs.value.emplace< ast::Probe * > ();
        break;

      case 75: // probes
        yylhs.value.emplace< ast::ProbeList * > ();
        break;

      case 84: // semicolon_ended_stmt
      case 86: // block_stmt
      case 87: // stmt
      case 88: // compound_assignment
        yylhs.value.emplace< ast::Statement * > ();
        break;

      case 83: // block
      case 85: // stmts
        yylhs.value.emplace< ast::StatementList * > ();
        break;

      case 81: // ternary
        yylhs.value.emplace< ast::Ternary * > ();
        break;

      case 95: // var
        yylhs.value.emplace< ast::Variable * > ();
        break;

      case 67: // "integer"
      case 68: // "colon surrounded integer"
        yylhs.value.emplace< long > ();
        break;

      case 55: // "builtin"
      case 56: // "call"
      case 57: // "call_builtin"
      case 58: // "identifier"
      case 59: // "path"
      case 60: // "preprocessor directive"
      case 61: // "struct definition"
      case 62: // "enum"
      case 63: // "string"
      case 64: // "map"
      case 65: // "variable"
      case 66: // "positional parameter"
      case 69: // "stack_mode"
      case 74: // c_definitions
      case 79: // wildcard
      case 92: // ident
        yylhs.value.emplace< std::string > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2:
#line 151 "src/parser.yy"
                               { driver.root_ = new ast::Program(yystack_[1].value.as < std::string > (), yystack_[0].value.as < ast::ProbeList * > ()); }
#line 1023 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 3:
#line 154 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\n" + yystack_[0].value.as < std::string > (); }
#line 1029 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 4:
#line 155 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1035 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 5:
#line 156 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1041 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 6:
#line 157 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = std::string(); }
#line 1047 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 7:
#line 160 "src/parser.yy"
                      { yylhs.value.as < ast::ProbeList * > () = yystack_[1].value.as < ast::ProbeList * > (); yystack_[1].value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1053 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 8:
#line 161 "src/parser.yy"
                      { yylhs.value.as < ast::ProbeList * > () = new ast::ProbeList; yylhs.value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1059 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 9:
#line 164 "src/parser.yy"
                                 { yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[2].value.as < ast::AttachPointList * > (), yystack_[1].value.as < ast::Predicate * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1065 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 10:
#line 167 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = yystack_[2].value.as < ast::AttachPointList * > (); yystack_[2].value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1071 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 11:
#line 168 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = new ast::AttachPointList; yylhs.value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1077 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 12:
#line 171 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1083 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 13:
#line 172 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[2].value.as < std::string > (), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1089 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 14:
#line 173 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[4].value.as < std::string > (), yystack_[2].value.as < std::string > (), yystack_[0].value.as < long > (), yylhs.location); }
#line 1095 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 15:
#line 174 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[2].value.as < std::string > (), yystack_[1].value.as < std::string > ().substr(1, yystack_[1].value.as < std::string > ().size()-2), yystack_[0].value.as < std::string > (), false, yylhs.location); }
#line 1101 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 16:
#line 175 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[2].value.as < std::string > (), yystack_[1].value.as < std::string > ().substr(1, yystack_[1].value.as < std::string > ().size()-2), yystack_[0].value.as < std::string > (), true, yylhs.location); }
#line 1107 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 17:
#line 176 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[4].value.as < std::string > (), yystack_[3].value.as < std::string > ().substr(1, yystack_[3].value.as < std::string > ().size()-2), yystack_[2].value.as < std::string > (), (uint64_t) yystack_[0].value.as < long > (), yylhs.location); }
#line 1113 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 18:
#line 177 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[4].value.as < std::string > (), yystack_[3].value.as < std::string > ().substr(1, yystack_[3].value.as < std::string > ().size()-2), yystack_[2].value.as < std::string > (), (uint64_t) yystack_[0].value.as < long > (), yylhs.location); }
#line 1119 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 19:
#line 178 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[2].value.as < std::string > (), yystack_[1].value.as < std::string > ().substr(1, yystack_[1].value.as < std::string > ().size()-2), yystack_[0].value.as < long > (), yylhs.location); }
#line 1125 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 20:
#line 179 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[4].value.as < std::string > (), yystack_[3].value.as < std::string > ().substr(1, yystack_[3].value.as < std::string > ().size()-2), yystack_[2].value.as < long > (), yystack_[1].value.as < long > (), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1131 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 21:
#line 180 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[4].value.as < std::string > (), yystack_[3].value.as < std::string > ().substr(1, yystack_[3].value.as < std::string > ().size()-2), yystack_[2].value.as < std::string > (), yystack_[0].value.as < std::string > (), false, yylhs.location); }
#line 1137 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 22:
#line 181 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[4].value.as < std::string > (), yystack_[3].value.as < std::string > ().substr(1, yystack_[3].value.as < std::string > ().size()-2), yystack_[2].value.as < std::string > (), yystack_[0].value.as < std::string > (), true, yylhs.location); }
#line 1143 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 23:
#line 182 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[4].value.as < std::string > (), yystack_[3].value.as < std::string > ().substr(1, yystack_[3].value.as < std::string > ().size()-2), yystack_[2].value.as < std::string > (), yystack_[0].value.as < std::string > (), true, yylhs.location); }
#line 1149 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 24:
#line 183 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[4].value.as < std::string > (), yystack_[3].value.as < std::string > ().substr(1, yystack_[3].value.as < std::string > ().size()-2), yystack_[2].value.as < std::string > (), yystack_[0].value.as < std::string > (), true, yylhs.location); }
#line 1155 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 25:
#line 186 "src/parser.yy"
                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1161 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 26:
#line 187 "src/parser.yy"
                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "*"; }
#line 1167 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 27:
#line 188 "src/parser.yy"
                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "["; }
#line 1173 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 28:
#line 189 "src/parser.yy"
                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "]"; }
#line 1179 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 29:
#line 190 "src/parser.yy"
                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "."; }
#line 1185 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 30:
#line 191 "src/parser.yy"
                             { yylhs.value.as < std::string > () = ""; }
#line 1191 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 31:
#line 194 "src/parser.yy"
                        { yylhs.value.as < ast::Predicate * > () = new ast::Predicate(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 1197 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 32:
#line 195 "src/parser.yy"
                        { yylhs.value.as < ast::Predicate * > () = nullptr; }
#line 1203 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 33:
#line 198 "src/parser.yy"
                                    { yylhs.value.as < ast::Ternary * > () = new ast::Ternary(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1209 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 34:
#line 201 "src/parser.yy"
                   { yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::positional, std::stoll(yystack_[0].value.as < std::string > ().substr(1, yystack_[0].value.as < std::string > ().size()-1)), yylhs.location); }
#line 1215 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 35:
#line 202 "src/parser.yy"
                   { yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::count, 0, yylhs.location); }
#line 1221 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 36:
#line 205 "src/parser.yy"
                          { yylhs.value.as < ast::StatementList * > () = yystack_[1].value.as < ast::StatementList * > (); }
#line 1227 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 37:
#line 208 "src/parser.yy"
                                { yylhs.value.as < ast::Statement * > () = yystack_[1].value.as < ast::Statement * > (); }
#line 1233 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 38:
#line 211 "src/parser.yy"
                                   { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[1].value.as < ast::Statement * > ()); }
#line 1239 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 39:
#line 212 "src/parser.yy"
                                   { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[1].value.as < ast::Statement * > ()); }
#line 1245 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 40:
#line 213 "src/parser.yy"
                                   { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->push_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1251 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 41:
#line 214 "src/parser.yy"
                                   { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; }
#line 1257 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 42:
#line 217 "src/parser.yy"
                                    { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1263 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 43:
#line 218 "src/parser.yy"
                                              { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::StatementList * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1269 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 44:
#line 219 "src/parser.yy"
                                      { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < long > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1275 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 45:
#line 222 "src/parser.yy"
                           { yylhs.value.as < ast::Statement * > () = new ast::ExprStatement(yystack_[0].value.as < ast::Expression * > ()); }
#line 1281 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 46:
#line 223 "src/parser.yy"
                           { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1287 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 47:
#line 224 "src/parser.yy"
                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1293 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 48:
#line 225 "src/parser.yy"
                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1299 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 49:
#line 228 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::LEFT,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1305 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 50:
#line 229 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::LEFT,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1311 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 51:
#line 230 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1317 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 52:
#line 231 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1323 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 53:
#line 232 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::PLUS,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1329 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 54:
#line 233 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::PLUS,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1335 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 55:
#line 234 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1341 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 56:
#line 235 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1347 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 57:
#line 236 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::MUL,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1353 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 58:
#line 237 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::MUL,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1359 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 59:
#line 238 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::DIV,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1365 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 60:
#line 239 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::DIV,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1371 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 61:
#line 240 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::MOD,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1377 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 62:
#line 241 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::MOD,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1383 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 63:
#line 242 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::BAND,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1389 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 64:
#line 243 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::BAND,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1395 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 65:
#line 244 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::BOR,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1401 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 66:
#line 245 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::BOR,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1407 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 67:
#line 246 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::BXOR,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1413 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 68:
#line 247 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::BXOR,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1419 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 69:
#line 250 "src/parser.yy"
                   { yylhs.value.as < ast::Integer * > () = new ast::Integer(-1 * yystack_[0].value.as < long > (), yylhs.location); }
#line 1425 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 70:
#line 251 "src/parser.yy"
                   { yylhs.value.as < ast::Integer * > () = new ast::Integer(yystack_[0].value.as < long > (), yylhs.location); }
#line 1431 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 71:
#line 254 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Integer * > (); }
#line 1437 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 72:
#line 255 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::String(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1443 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 73:
#line 256 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1449 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 74:
#line 257 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1455 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 75:
#line 258 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Identifier(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1461 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 76:
#line 259 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::StackMode(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1467 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 77:
#line 260 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Ternary * > (); }
#line 1473 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 78:
#line 261 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::PositionalParameter * > (); }
#line 1479 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 79:
#line 262 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1485 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 80:
#line 263 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Call * > (); }
#line 1491 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 81:
#line 264 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[1].value.as < ast::Expression * > (); }
#line 1497 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 82:
#line 265 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::EQ, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1503 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 83:
#line 266 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::NE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1509 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 84:
#line 267 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1515 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 85:
#line 268 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::GE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1521 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 86:
#line 269 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1527 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 87:
#line 270 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::GT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1533 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 88:
#line 271 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LAND,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1539 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 89:
#line 272 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LOR,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1545 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 90:
#line 273 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LEFT,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1551 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 91:
#line 274 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1557 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 92:
#line 275 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::PLUS,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1563 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 93:
#line 276 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1569 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 94:
#line 277 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MUL,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1575 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 95:
#line 278 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::DIV,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1581 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 96:
#line 279 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MOD,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1587 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 97:
#line 280 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BAND,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1593 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 98:
#line 281 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BOR,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1599 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 99:
#line 282 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BXOR,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1605 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 100:
#line 283 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::LNOT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1611 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 101:
#line 284 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::BNOT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1617 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 102:
#line 285 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1623 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 103:
#line 286 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::MUL,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1629 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 104:
#line 287 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < std::string > (), yystack_[1].location); }
#line 1635 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 105:
#line 288 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(new ast::Unop(token::MUL, yystack_[2].value.as < ast::Expression * > (), yystack_[1].location), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1641 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 106:
#line 289 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::ArrayAccess(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < ast::Expression * > (), yystack_[2].location + yystack_[0].location); }
#line 1647 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 107:
#line 290 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[2].value.as < std::string > (), false, yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 1653 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 108:
#line 291 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[3].value.as < std::string > (), true, yystack_[0].value.as < ast::Expression * > (), yystack_[4].location + yystack_[1].location); }
#line 1659 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 109:
#line 292 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1665 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 110:
#line 296 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::INCREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1671 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 111:
#line 297 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::DECREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1677 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 112:
#line 298 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::INCREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1683 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 113:
#line 299 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::DECREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1689 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 114:
#line 300 "src/parser.yy"
                                   { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1695 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 115:
#line 301 "src/parser.yy"
                                   { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1701 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 116:
#line 302 "src/parser.yy"
                                   { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1707 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 117:
#line 303 "src/parser.yy"
                                   { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1713 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 118:
#line 306 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1719 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 119:
#line 307 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1725 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 120:
#line 308 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1731 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 121:
#line 309 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1737 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 122:
#line 310 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1743 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 123:
#line 313 "src/parser.yy"
                                    { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 1749 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 124:
#line 314 "src/parser.yy"
                                    { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1755 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 125:
#line 315 "src/parser.yy"
                                    { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 1761 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 126:
#line 316 "src/parser.yy"
                                    { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1767 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 127:
#line 317 "src/parser.yy"
                                    { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1773 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 128:
#line 318 "src/parser.yy"
                                    { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1779 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 129:
#line 319 "src/parser.yy"
                                    { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1785 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 130:
#line 320 "src/parser.yy"
                                    { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1791 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 131:
#line 321 "src/parser.yy"
                                    { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1797 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 132:
#line 322 "src/parser.yy"
                                    { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1803 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 133:
#line 325 "src/parser.yy"
                        { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1809 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 134:
#line 326 "src/parser.yy"
                        { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1815 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 135:
#line 329 "src/parser.yy"
          { yylhs.value.as < ast::Variable * > () = new ast::Variable(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1821 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 136:
#line 332 "src/parser.yy"
                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Variable * > (); }
#line 1827 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 137:
#line 333 "src/parser.yy"
                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Map * > (); }
#line 1833 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 138:
#line 336 "src/parser.yy"
                       { yylhs.value.as < ast::ExpressionList * > () = yystack_[2].value.as < ast::ExpressionList * > (); yystack_[2].value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 1839 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;

  case 139:
#line 337 "src/parser.yy"
                       { yylhs.value.as < ast::ExpressionList * > () = new ast::ExpressionList; yylhs.value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 1845 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"
    break;


#line 1849 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yy_error_token_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yy_error_token_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = static_cast<state_type> (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
   Parser ::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  // Generate an error message.
  std::string
   Parser ::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    std::ptrdiff_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */
    if (!yyla.empty ())
      {
        symbol_number_type yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];

        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yy_error_token_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short  Parser ::yypact_ninf_ = -208;

  const signed char  Parser ::yytable_ninf_ = -123;

  const short
   Parser ::yypact_[] =
  {
      81,    81,    81,    81,     6,   174,  -208,  -208,  -208,  -208,
    -208,  -208,  -208,  -208,  -208,   174,  -208,    -8,  -208,    -1,
    -208,   174,   405,    14,  -208,   -42,  -208,   439,  -208,   129,
     473,   129,   405,   405,   405,    84,    18,    97,   101,  -208,
      40,  -208,  -208,  -208,   173,  -208,  -208,  -208,   577,  -208,
      -7,  -208,  -208,  -208,    59,   201,  -208,   165,    15,    31,
      77,    82,   617,  -208,  -208,  -208,    -3,  -208,  -208,     0,
       0,     0,   235,   269,   303,   337,   405,   371,   405,   405,
    -208,   405,   405,   405,   405,   405,   405,   405,   405,   405,
     405,   405,   405,   405,   405,   405,   405,   405,   405,   174,
     174,  -208,  -208,  -208,  -208,    52,    73,   201,   102,   201,
     115,  -208,   735,   537,   576,  -208,  -208,    53,  -208,  -208,
    -208,    63,    72,   174,   111,    78,   405,   179,  -208,  -208,
     735,    43,  -208,    44,  -208,    91,  -208,    92,     4,  -208,
     103,   656,   538,   997,   997,     2,     2,    89,    89,     2,
       2,   852,   813,    -3,    -3,     0,     0,     0,   965,   891,
     928,  -208,  -208,   405,   108,  -208,  -208,  -208,  -208,   405,
     405,   405,   405,   405,   405,   405,   405,   405,   405,   405,
     405,   405,   405,   405,   405,   405,   405,   405,   405,   405,
     405,  -208,  -208,   169,  -208,  -208,  -208,   169,  -208,     0,
     405,  -208,   405,  -208,  -208,  -208,  -208,  -208,  -208,   405,
     696,   185,   735,   735,   735,   735,   735,   735,   735,   735,
     735,   735,   735,   735,   735,   735,   735,   735,   735,   735,
     735,   735,   735,   735,     0,   735,   774,    14,    14,   128,
    -208,    14,  -208
  };

  const unsigned char
   Parser ::yydefact_[] =
  {
       6,     6,     6,     6,     0,     0,     3,     4,     5,     1,
     119,   120,   121,   118,   122,     2,     8,    32,    11,    12,
       7,     0,     0,     0,    30,    30,    10,     0,    35,     0,
       0,     0,     0,     0,     0,    73,   120,    74,    75,    72,
     133,   135,    34,    70,    76,    77,    78,    71,     0,   109,
       0,    80,   137,   136,    79,    41,     9,    13,    15,    19,
      16,    75,     0,   115,   112,    69,   102,   117,   113,   103,
     100,   101,     0,     0,     0,     0,     0,     0,     0,     0,
      31,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   114,   116,   110,   111,     0,     0,    41,     0,    41,
      40,    46,    45,   137,   136,    27,    28,     0,    26,    29,
      25,    30,     0,     0,    30,     0,     0,     0,    81,   129,
     139,     0,   123,     0,   125,     0,   127,     0,     0,   131,
       0,     0,     0,    82,    83,    84,    85,    90,    91,    86,
      87,    88,    89,    92,    93,    94,    95,    96,    97,    98,
      99,   104,   105,     0,     0,    38,    36,    39,    37,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    14,    21,    22,    18,    20,    23,    24,    17,   107,
       0,   130,     0,   124,   126,   128,   134,   132,   106,     0,
       0,     0,    47,    49,    51,    53,    55,    57,    59,    61,
      63,    65,    67,    48,    50,    52,    54,    56,    58,    60,
      62,    64,    66,    68,   108,   138,    33,     0,     0,    42,
      44,     0,    43
  };

  const short
   Parser ::yypgoto_[] =
  {
    -208,  -208,   146,  -208,   181,  -208,   176,   -24,  -208,  -208,
    -208,  -207,  -208,     5,  -208,  -208,  -208,  -208,   -19,  -208,
      -5,  -208,   -26,   -20,   149,   211
  };

  const short
   Parser ::yydefgoto_[] =
  {
      -1,     4,     5,    15,    16,    17,    18,    57,    23,    45,
      46,    56,   107,   108,   109,   110,   111,    47,   130,    49,
      50,    51,    52,    53,    54,   131
  };

  const short
   Parser ::yytable_[] =
  {
      19,    60,    24,    48,    78,    21,     9,    78,    62,    78,
      19,    66,   206,    69,    70,    71,    19,   202,   121,    55,
     101,    58,    85,    86,    63,    59,    67,    73,    91,   113,
     239,   240,   102,    22,   242,   114,   112,    93,    94,    95,
      92,   122,    93,    94,    95,    99,   100,    76,    99,   100,
      99,   100,   120,   201,   203,   120,   202,   202,    25,   141,
     142,   163,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     124,   113,   164,   113,   115,   116,   103,   114,   112,   114,
     112,    75,   126,    72,   161,   162,    78,   193,   104,   123,
     197,   204,   205,   125,   202,   202,    74,   199,   166,  -118,
      75,  -119,   165,   207,   167,    91,   202,   118,   195,   168,
     191,  -118,   127,  -119,  -121,   119,   192,    92,  -118,    93,
      94,    95,    10,    11,    12,    13,  -121,    99,   100,   194,
    -118,     1,     2,     3,   210,   198,    14,     6,     7,     8,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   115,   116,   196,   211,   115,   116,    64,   241,
      68,   234,    77,   235,    10,    11,    12,    13,   120,   200,
     236,   117,   120,    40,    41,   238,    20,    26,    14,     0,
    -122,     0,     0,     0,     0,   118,     0,     0,     0,   118,
      27,     0,  -122,   119,     0,    28,     0,   119,     0,     0,
      10,    11,    12,    13,    10,    11,    12,    13,    29,    10,
      11,    12,    13,     0,    14,     0,     0,     0,    14,    30,
      31,    32,     0,    14,    27,   129,     0,    33,    34,    28,
       0,   105,     0,   106,     0,     0,    35,    36,    37,    38,
       0,     0,    29,     0,    39,    40,    41,    42,    43,     0,
      44,     0,     0,    30,    31,    32,     0,     0,    27,   132,
       0,    33,    34,    28,   133,   135,   137,   138,   140,     0,
      35,    36,    37,    38,     0,     0,    29,     0,    39,    40,
      41,    42,    43,     0,    44,     0,     0,    30,    31,    32,
       0,     0,    27,   134,     0,    33,    34,    28,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,     0,     0,
      29,     0,    39,    40,    41,    42,    43,     0,    44,     0,
       0,    30,    31,    32,     0,     0,    27,   136,     0,    33,
      34,    28,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,     0,     0,    29,     0,    39,    40,    41,    42,
      43,     0,    44,     0,     0,    30,    31,    32,     0,     0,
      27,   139,     0,    33,    34,    28,     0,     0,     0,     0,
       0,     0,    35,    36,    37,    38,     0,     0,    29,     0,
      39,    40,    41,    42,    43,     0,    44,     0,     0,    30,
      31,    32,     0,     0,    27,     0,     0,    33,    34,    28,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
       0,     0,    29,     0,    39,    40,    41,    42,    43,     0,
      44,     0,     0,    30,    31,    32,     0,     0,    27,     0,
       0,    33,    34,    28,     0,     0,     0,     0,     0,     0,
      35,    36,    37,    38,     0,     0,    29,     0,    39,    40,
      41,    42,    43,     0,    44,     0,     0,    30,    31,    32,
       0,     0,    27,     0,     0,    33,    34,    28,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    61,     0,     0,
      29,     0,    39,    40,    41,    42,    43,     0,    44,     0,
       0,    30,    31,    32,     0,     0,     0,     0,     0,    33,
      34,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,     0,     0,     0,     0,    39,    40,    41,    42,
      65,   209,    44,     0,     0,    78,     0,     0,     0,    79,
       0,     0,   169,     0,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,     0,    92,     0,    93,    94,
      95,    96,    97,    98,    78,     0,    99,   100,    79,    80,
       0,   180,     0,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,     0,    92,     0,    93,    94,    95,
      96,    97,    98,     0,    78,    99,   100,   128,    79,     0,
       0,     0,     0,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    92,     0,    93,    94,    95,
      96,    97,    98,    78,   208,    99,   100,    79,     0,     0,
       0,     0,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    92,     0,    93,    94,    95,    96,
      97,    98,     0,    78,    99,   100,   237,    79,     0,     0,
       0,     0,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    92,     0,    93,    94,    95,    96,
      97,    98,    78,     0,    99,   100,    79,     0,     0,     0,
       0,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    92,     0,    93,    94,    95,    96,    97,
      98,    78,     0,    99,   100,     0,     0,     0,     0,     0,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    92,     0,    93,    94,    95,    96,    97,    98,
      78,     0,    99,   100,     0,     0,     0,     0,     0,    81,
      82,    83,    84,    85,    86,    87,    88,    89,     0,    91,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    92,     0,    93,    94,    95,    96,    97,    98,    78,
       0,    99,   100,     0,     0,     0,     0,     0,    81,    82,
      83,    84,    85,    86,    87,    88,     0,     0,    91,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      92,     0,    93,    94,    95,    96,    97,    98,    78,     0,
      99,   100,     0,     0,     0,     0,     0,    81,    82,    83,
      84,    85,    86,    87,    88,     0,     0,    91,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    92,
       0,    93,    94,    95,    96,    78,    98,     0,     0,    99,
     100,     0,     0,     0,    81,    82,    83,    84,    85,    86,
      87,    88,     0,     0,    91,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    92,     0,    93,    94,
      95,    96,    78,     0,     0,     0,    99,   100,     0,     0,
       0,    81,    82,    83,    84,    85,    86,    87,    88,     0,
       0,    91,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    92,    78,    93,    94,    95,     0,     0,
       0,     0,     0,    99,   100,    83,    84,    85,    86,    87,
      88,     0,     0,    91,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    92,     0,    93,    94,    95,
       0,     0,     0,     0,     0,    99,   100
  };

  const short
   Parser ::yycheck_[] =
  {
       5,    25,     3,    22,     7,    13,     0,     7,    27,     7,
      15,    30,     8,    32,    33,    34,    21,    13,     3,     5,
      27,    63,    20,    21,    29,    67,    31,     9,    26,    55,
     237,   238,    39,    41,   241,    55,    55,    40,    41,    42,
      38,    26,    40,    41,    42,    48,    49,     7,    48,    49,
      48,    49,    57,    10,    10,    60,    13,    13,    59,    78,
      79,     9,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
       3,   107,     9,   109,     7,     8,    27,   107,   107,   109,
     109,     9,    10,     9,    99,   100,     7,   121,    39,    68,
     124,    10,    10,    26,    13,    13,     9,   126,     6,    27,
       9,    27,   107,    10,   109,    26,    13,    40,   123,     4,
      67,    39,    40,    39,    27,    48,    63,    38,    27,    40,
      41,    42,    55,    56,    57,    58,    39,    48,    49,    67,
      39,    60,    61,    62,   163,    67,    69,     1,     2,     3,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,     7,     8,    63,    67,     7,     8,    29,    51,
      31,   200,     9,   202,    55,    56,    57,    58,   193,    10,
     209,    26,   197,    64,    65,    10,    15,    21,    69,    -1,
      27,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    40,
       9,    -1,    39,    48,    -1,    14,    -1,    48,    -1,    -1,
      55,    56,    57,    58,    55,    56,    57,    58,    27,    55,
      56,    57,    58,    -1,    69,    -1,    -1,    -1,    69,    38,
      39,    40,    -1,    69,     9,    10,    -1,    46,    47,    14,
      -1,    50,    -1,    52,    -1,    -1,    55,    56,    57,    58,
      -1,    -1,    27,    -1,    63,    64,    65,    66,    67,    -1,
      69,    -1,    -1,    38,    39,    40,    -1,    -1,     9,    10,
      -1,    46,    47,    14,    73,    74,    75,    76,    77,    -1,
      55,    56,    57,    58,    -1,    -1,    27,    -1,    63,    64,
      65,    66,    67,    -1,    69,    -1,    -1,    38,    39,    40,
      -1,    -1,     9,    10,    -1,    46,    47,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    55,    56,    57,    58,    -1,    -1,
      27,    -1,    63,    64,    65,    66,    67,    -1,    69,    -1,
      -1,    38,    39,    40,    -1,    -1,     9,    10,    -1,    46,
      47,    14,    -1,    -1,    -1,    -1,    -1,    -1,    55,    56,
      57,    58,    -1,    -1,    27,    -1,    63,    64,    65,    66,
      67,    -1,    69,    -1,    -1,    38,    39,    40,    -1,    -1,
       9,    10,    -1,    46,    47,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    55,    56,    57,    58,    -1,    -1,    27,    -1,
      63,    64,    65,    66,    67,    -1,    69,    -1,    -1,    38,
      39,    40,    -1,    -1,     9,    -1,    -1,    46,    47,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    55,    56,    57,    58,
      -1,    -1,    27,    -1,    63,    64,    65,    66,    67,    -1,
      69,    -1,    -1,    38,    39,    40,    -1,    -1,     9,    -1,
      -1,    46,    47,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      55,    56,    57,    58,    -1,    -1,    27,    -1,    63,    64,
      65,    66,    67,    -1,    69,    -1,    -1,    38,    39,    40,
      -1,    -1,     9,    -1,    -1,    46,    47,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    55,    56,    57,    58,    -1,    -1,
      27,    -1,    63,    64,    65,    66,    67,    -1,    69,    -1,
      -1,    38,    39,    40,    -1,    -1,    -1,    -1,    -1,    46,
      47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    56,
      57,    58,    -1,    -1,    -1,    -1,    63,    64,    65,    66,
      67,     3,    69,    -1,    -1,     7,    -1,    -1,    -1,    11,
      -1,    -1,    15,    -1,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    -1,    38,    -1,    40,    41,
      42,    43,    44,    45,     7,    -1,    48,    49,    11,    12,
      -1,    15,    -1,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    -1,    38,    -1,    40,    41,    42,
      43,    44,    45,    -1,     7,    48,    49,    10,    11,    -1,
      -1,    -1,    -1,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,
      43,    44,    45,     7,     8,    48,    49,    11,    -1,    -1,
      -1,    -1,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,    43,
      44,    45,    -1,     7,    48,    49,    10,    11,    -1,    -1,
      -1,    -1,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,    43,
      44,    45,     7,    -1,    48,    49,    11,    -1,    -1,    -1,
      -1,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    38,    -1,    40,    41,    42,    43,    44,
      45,     7,    -1,    48,    49,    -1,    -1,    -1,    -1,    -1,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    38,    -1,    40,    41,    42,    43,    44,    45,
       7,    -1,    48,    49,    -1,    -1,    -1,    -1,    -1,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    -1,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    38,    -1,    40,    41,    42,    43,    44,    45,     7,
      -1,    48,    49,    -1,    -1,    -1,    -1,    -1,    16,    17,
      18,    19,    20,    21,    22,    23,    -1,    -1,    26,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      38,    -1,    40,    41,    42,    43,    44,    45,     7,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,
      19,    20,    21,    22,    23,    -1,    -1,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,
      -1,    40,    41,    42,    43,     7,    45,    -1,    -1,    48,
      49,    -1,    -1,    -1,    16,    17,    18,    19,    20,    21,
      22,    23,    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,
      42,    43,     7,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
      -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    38,     7,    40,    41,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    18,    19,    20,    21,    22,
      23,    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49
  };

  const signed char
   Parser ::yystos_[] =
  {
       0,    60,    61,    62,    73,    74,    74,    74,    74,     0,
      55,    56,    57,    58,    69,    75,    76,    77,    78,    92,
      76,    13,    41,    80,     3,    59,    78,     9,    14,    27,
      38,    39,    40,    46,    47,    55,    56,    57,    58,    63,
      64,    65,    66,    67,    69,    81,    82,    89,    90,    91,
      92,    93,    94,    95,    96,     5,    83,    79,    63,    67,
      79,    58,    90,    92,    96,    67,    90,    92,    96,    90,
      90,    90,     9,     9,     9,     9,     7,     9,     7,    11,
      12,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    38,    40,    41,    42,    43,    44,    45,    48,
      49,    27,    39,    27,    39,    50,    52,    84,    85,    86,
      87,    88,    90,    94,    95,     7,     8,    26,    40,    48,
      92,     3,    26,    68,     3,    26,    10,    40,    10,    10,
      90,    97,    10,    97,    10,    97,    10,    97,    97,    10,
      97,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    92,    92,     9,     9,    85,     6,    85,     4,    15,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      15,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    67,    63,    79,    67,    92,    63,    79,    67,    90,
      10,    10,    13,    10,    10,    10,     8,    10,     8,     3,
      90,    67,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    10,    10,    83,
      83,    51,    83
  };

  const signed char
   Parser ::yyr1_[] =
  {
       0,    72,    73,    74,    74,    74,    74,    75,    75,    76,
      77,    77,    78,    78,    78,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    78,    79,    79,    79,    79,    79,
      79,    80,    80,    81,    82,    82,    83,    84,    85,    85,
      85,    85,    86,    86,    86,    87,    87,    87,    87,    88,
      88,    88,    88,    88,    88,    88,    88,    88,    88,    88,
      88,    88,    88,    88,    88,    88,    88,    88,    88,    89,
      89,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      91,    91,    91,    91,    91,    91,    91,    91,    92,    92,
      92,    92,    92,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    94,    94,    95,    96,    96,    97,    97
  };

  const signed char
   Parser ::yyr2_[] =
  {
       0,     2,     2,     2,     2,     2,     0,     2,     1,     3,
       3,     1,     1,     3,     5,     3,     3,     5,     5,     3,
       5,     5,     5,     5,     5,     2,     2,     2,     2,     2,
       0,     3,     0,     5,     1,     1,     3,     2,     2,     2,
       1,     0,     5,     7,     5,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     2,     2,     3,     3,     4,     4,     5,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     1,     1,     3,     4,     3,     4,     3,     4,     3,
       4,     3,     4,     1,     4,     1,     1,     1,     3,     1
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const  Parser ::yytname_[] =
  {
  "\"end of file\"", "error", "$undefined", "\":\"", "\";\"", "\"{\"",
  "\"}\"", "\"[\"", "\"]\"", "\"(\"", "\")\"", "\"?\"",
  "\"end predicate\"", "\",\"", "\"$#\"", "\"=\"", "\"==\"", "\"!=\"",
  "\"<=\"", "\">=\"", "\"<<\"", "\">>\"", "\"<\"", "\">\"", "\"&&\"",
  "\"||\"", "\"+\"", "\"++\"", "\"<<=\"", "\">>=\"", "\"+=\"", "\"-=\"",
  "\"*=\"", "\"/=\"", "\"%=\"", "\"&=\"", "\"|=\"", "\"^=\"", "\"-\"",
  "\"--\"", "\"*\"", "\"/\"", "\"%\"", "\"&\"", "\"|\"", "\"^\"", "\"!\"",
  "\"~\"", "\".\"", "\"->\"", "\"if\"", "\"else\"", "\"unroll\"",
  "\"struct\"", "\"union\"", "\"builtin\"", "\"call\"", "\"call_builtin\"",
  "\"identifier\"", "\"path\"", "\"preprocessor directive\"",
  "\"struct definition\"", "\"enum\"", "\"string\"", "\"map\"",
  "\"variable\"", "\"positional parameter\"", "\"integer\"",
  "\"colon surrounded integer\"", "\"stack_mode\"", "DEREF", "CAST",
  "$accept", "program", "c_definitions", "probes", "probe",
  "attach_points", "attach_point", "wildcard", "pred", "ternary", "param",
  "block", "semicolon_ended_stmt", "stmts", "block_stmt", "stmt",
  "compound_assignment", "int", "expr", "pre_post_op", "ident", "call",
  "map", "var", "map_or_var", "vargs", YY_NULLPTR
  };

#if YYDEBUG
  const short
   Parser ::yyrline_[] =
  {
       0,   151,   151,   154,   155,   156,   157,   160,   161,   164,
     167,   168,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   186,   187,   188,   189,   190,
     191,   194,   195,   198,   201,   202,   205,   208,   211,   212,
     213,   214,   217,   218,   219,   222,   223,   224,   225,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   250,
     251,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     296,   297,   298,   299,   300,   301,   302,   303,   306,   307,
     308,   309,   310,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   325,   326,   329,   332,   333,   336,   337
  };

  // Print the state stack on the debug stream.
  void
   Parser ::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
   Parser ::yy_reduce_print_ (int yyrule)
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 4 "src/parser.yy"
} //  bpftrace 
#line 2567 "/builddir/build/BUILD/bpftrace-0.9.4/parser.tab.cc"

#line 340 "src/parser.yy"


void bpftrace::Parser::error(const location &l, const std::string &m)
{
  driver.error(l, m);
}
